
"""
Description of the Puzzling Paths.
This is a very basic version of a general problem in computer science.
How to cross a network along the shortest path or along a path that visits every node once.
This problem has 6 nodes.
Start Node is node 1 and End Node is node 6.
The program will recursively go through the network and list all paths from n1 to n6.
(Recursion is dealt with in the lesson slides.)


"""

import time

"""
A definition(function) for describing a node .. each attribute is described:
    vertex is an integer from 1-6
    nodeList is the list of other nodes connected to this node

    coords will be used  for the graphical (Turtle) output (not used in this standalone version)
        
"""
def createNode (number, nodeList) :
    node = {"vertex": number, "nodeList":nodeList}
    return node

def Network_Traipse(node, pathlist) :
    pathlist = pathlist + [node["vertex"]]
    #print(pathlist) # debug statement

    if node == endNode :
        print('pathlist ', pathlist)
        listOfPaths.append(pathlist)
        return

    for tempnode in node["nodeList"] :
        if tempnode["vertex"] not in pathlist :
            #print("tempnode ", tempnode.number) # debugging prints
            Network_Traipse(tempnode, pathlist)
    return



# Initialise the nodal network 
node1 = createNode(1,[])
node2 = createNode(2,[])
node3 = createNode(3,[])
node4 = createNode(4,[])
node5 = createNode(5,[])
node6 = createNode(6,[])

node1["nodeList"] = [node2]
node2["nodeList"] = [node3, node5]
node3["nodeList"] = [node2, node4, node5]
node4["nodeList"] = [node3, node5, node6]
node5["nodeList"] = [node2, node3, node4]
node6["nodeList"] = [node4]

startNode = node1
endNode = node6

startTime = time.clock()
pathlist = [] #store paths as a list of integers, representing the nodes
listOfPaths = [] #an unfiltered list of paths from start - end
Network_Traipse(startNode, pathlist)
endTime = time.clock()
for possPaths in listOfPaths :
    if len(possPaths) == endNode["vertex"] - startNode["vertex"] + 1 :
        print("Hamiltonian Path = 1 visit per node ", possPaths)

print ("time taken is ", format(endTime - startTime,'.2f'), "seconds")
   





